// to make the proc_macros work inside the microrm crate; needed for tests and the metaschema.
extern crate self as microrm;

pub mod db;
pub mod entity;
mod query;
pub mod schema;

pub mod prelude {
    pub use microrm_macros::{Database, Entity};
    // pub use crate::entity::
}

// ----------------------------------------------------------------------
// Generically-useful database types
// ----------------------------------------------------------------------

#[derive(Debug)]
pub enum DBError {
    EmptyResult,
    LogicError(&'static str),
    Sqlite(sqlite::Error),
    LockError(String),
}

impl From<sqlite::Error> for DBError {
    fn from(value: sqlite::Error) -> Self {
        Self::Sqlite(value)
    }
}

impl<T> From<std::sync::PoisonError<T>> for DBError {
    fn from(value: std::sync::PoisonError<T>) -> Self {
        Self::LockError(value.to_string())
    }
}

pub type DBResult<T> = Result<T, DBError>;
